#include <QtGui>
#include "form.h"

static void childsRecursive(QObject *object, QWidget *watcher, bool install)
{
    if (object->isWidgetType()) {
        if (install) object->installEventFilter(watcher);
        else object->removeEventFilter(watcher);
    }
    QObjectList children = object->children();
    foreach(QObject *child, children) {
        childsRecursive(child, watcher, install);
    }
}

form::form(QWidget *parent) : QMainWindow(parent)
{
    resize(300, 100);
    centralwidget = new QWidget(this);
    setCentralWidget(centralwidget);

    QTextEdit *textedit = new QTextEdit(centralwidget);
    QRadioButton *rb = new QRadioButton("radioButton", centralwidget);
    QCheckBox *cb = new QCheckBox("checkBox", centralwidget);
    QComboBox *cmb = new QComboBox(centralwidget);
    QPushButton *btn = new QPushButton("text", textedit);

    QVBoxLayout *vl = new QVBoxLayout(centralwidget);
    vl->addWidget(textedit);
    vl->addWidget(btn);
    vl->addWidget(cb);
    vl->addWidget(cmb);
    vl->addWidget(rb);

    centralwidget->setLayout(vl);
    childsRecursive(centralwidget, this, true);
}


bool form::eventFilter(QObject *obj, QEvent *event)
{
    if(event->type() == QEvent::Paint) {
        obj->removeEventFilter(this);
        QApplication::sendEvent(obj, event);
        obj->installEventFilter(this);

        QWidget *widget = qobject_cast<QWidget*>(obj);
        QPoint point = widget->pos();
        while(widget && (widget->parentWidget() != this)) {
            widget = widget->parentWidget();
            point += widget->pos();
        }

        QRect r = qobject_cast<QWidget*>(obj)->rect().translated(point);

        QPainter p(qobject_cast<QWidget*>(obj));
        p.setWindow(r);

        QPixmap pix(size());
        pix.load("../govno.gif");
        p.drawPixmap(rect(), pix);

        return true;
    }
    return false;
}


